﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Charting;

namespace SilverlightSupport
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            string[] fruits = new string[] { "Apples", "Oranges", "Grapes" };
            RadChart1.ItemsSource = new List<Product>()
            {
                new Product() { Fruit = fruits[0], Orders = 41 },
                new Product() { Fruit = fruits[1], Orders = 33 },
                new Product() { Fruit = fruits[2], Orders = 25 }
            };

            RadChart1.DefaultView.ChartArea.MouseLeftButtonUp += new MouseButtonEventHandler(ChartArea_MouseLeftButtonUp);
        }

        void ChartArea_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Series clickedItem = GetParent<Series>(e.OriginalSource as DependencyObject);
            if (clickedItem != null)
            {
                SeriesItemLabel_Click(clickedItem, e);
            }
        }

        protected virtual void SeriesItemLabel_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Click!");
        }

        private T GetParent<T>(DependencyObject obj)
            where T : DependencyObject
        {
            if (obj == null)
            {
                return null;
            }
            else if (obj is T)
            {
                return (T)obj;
            }

            DependencyObject parent = VisualTreeHelper.GetParent(obj);
            return GetParent<T>(parent);
        }
    }

    public class Product
    {
        public string Fruit { get; set; }
        public int Orders { get; set; }
    }
}
